Subject: Re: netfilter: active obj WARN when cleaning up

From: Greg KH <[email-masked]>
Date: Mon, 2 Dec 2013 11:08:14 -0800

On Mon, Dec 02, 2013 at 07:00:23PM +0000, Christoph Lameter wrote:
> On Mon, 2 Dec 2013, Greg KH wrote:
> 
> > >
> > > We need our own reference count. So we just have to defer the
> > > release of the kmem_cache struct until the ->release callback is
> > > triggered. The put of the embedded kobject must be the last action on the
> > > kmem_cache  structure which will then trigger release and that will
> > > trigger the kmem_cache_free().
> > >
> >
> > Ok, that sounds reasonable, or you can just create a "tiny" structure
> > for the kobject that has a pointer back to your kmem_cache structure
> > that you can then reference from the show/store functions.  Either is
> > fine with me.
> 
> Problem is that the release field is only available if
> CONFIG_DEBUG_KOBJECT_RELEASE is enabled. Without the callback I cannot
> tell when it is legit to release the kobject structure unless I keep
> scanning it once in awhile.

No, the release callback is in the kobj_type, not the kobject itself.

--
To unsubscribe, send a message with 'unsubscribe linux-mm' in
the body to [email-masked].  For more info on Linux MM,
see: http://www.linux-mm.org/ .
Don't email: <a href=mailto:"[email-masked]"> [email-masked] </a>